stages: [build, deploy]

build:
  image: node:14-alpine3.12
  stage: build
  script:
    - apk update && \
      apk upgrade && \
      apk add --no-cache \
      alpine-sdk \
      git \
      openssh \
      python3 \
      tzdata \
      build-base \
      libtool \
      autoconf \
      automake \
      gzip \
      g++ \
      make
    - npm i
    - npm run build
  only:
    - master
    
deploy:
  image: docker:latest
  stage: deploy
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - |
      if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
        tag=""
        echo "Running on default branch '$CI_DEFAULT_BRANCH': tag = 'latest'"
      else
        tag=":$CI_COMMIT_REF_SLUG"
        echo "Running on branch '$CI_COMMIT_BRANCH': tag = $tag"
      fi
    - docker build --pull -t "$CI_REGISTRY_IMAGE${tag}" .
    - docker push "$CI_REGISTRY_IMAGE${tag}"

  only:
    - master
